﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;

namespace UltraTreeNodeSelection
{
    public partial class Form1 : Form
    {

        public ContextMenu cm;
        private bool IsSelectedNode;
        public Form1()
        {
            InitializeComponent();
            cm = new System.Windows.Forms.ContextMenu();
            cm.MenuItems.Add("Copy");
            cm.MenuItems.Add("Past");
            cm.MenuItems.Add("Delete");
        }
        private void ultraTree1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Right)
            {
                UltraTreeNode node = ultraTree1.GetNodeFromPoint(e.X, e.Y);
                if (node != null)
                {
                    IsSelectedNode = true;
                    node.Override.ActiveNodeAppearance.BackColor = Color.Yellow;
                    ultraTree1.ActiveNode = node;
                    List<UltraTreeNode> list = new List<UltraTreeNode>();
                    list.Add(node);
                    ultraTree1.SelectedNodes.AddRange(list, true);

                }
                else
                {
                    IsSelectedNode = false;
                    
                }
            }
        }

        private void ultraTree1_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Right)
            {
                if (IsSelectedNode)
                {
                    ultraTree1.ContextMenu = cm;
                    ultraTree1.ContextMenu.Show(ultraTree1, new Point(e.X, e.Y));
                }
                else ultraTree1.ContextMenu = null;
            }
        }
    }
}
